#ifndef ACTIONS_H
#define ACTIONS_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "folder_dialog.h"
#include "main_widget.h"
#include "pref_dialog.h"

class Actions : public QObject
{
    Q_OBJECT

private:

    QWidget  *mainGui;
    shared_t *conf;

    void openFld(bool preFill);

public slots:

    void openFldDialog();
    void openFldConfDialog();
    void openAboutDialog();
    void openAppConfDialog();
    void closeApp();
    void closeSession();
    void rmRecents();

public:

    QMenu *fileMenu;
    QMenu *editMenu;
    QMenu *helpMenu;
    QMenu *recents;
    QMenu *liveSelect;
    QMenu *footageSelect;

    QAction *openFolder;
    QAction *openFolderConf;
    QAction *closeFolder;
    QAction *exitApp;
    QAction *about;
    QAction *pref;
    QAction *live;
    QAction *footage;
    QAction *clearRecents;
    QAction *recentsSpacer;

    void openConf(const QString &path);
    void rebuildRecents();

    explicit Actions(shared_t *share, QMenuBar *menuBar, QWidget *parent);

signals:

    void contentOpen();
    void contentClose();
};

#endif // ACTIONS_H
