#ifndef COMMON_H
#define COMMON_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include <QCoreApplication>
#include <QStringList>
#include <QApplication>
#include <QMainWindow>
#include <QMenuBar>
#include <QVideoWidget>
#include <QDir>
#include <QFile>
#include <QAction>
#include <QDialog>
#include <QFileDialog>
#include <QErrorMessage>
#include <QThread>
#include <QProcess>
#include <QFileSystemWatcher>
#include <QDateTime>
#include <QMessageBox>
#include <QSysInfo>
#include <QStackedWidget>
#include <QGridLayout>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QBoxLayout>
#include <QPushButton>
#include <QSpinBox>
#include <QLineEdit>
#include <QCheckBox>
#include <QFormLayout>
#include <QLabel>
#include <QList>
#include <QTimerEvent>
#include <QShowEvent>
#include <QCursor>
#include <QUrl>
#include <QPixmap>
#include <QPainter>
#include <QScrollArea>
#include <QScrollBar>
#include <QTimer>
#include <QTime>
#include <QScreen>
#include <QVideoFrame>
#include <QVideoSink>
#include <QRadioButton>
#include <QToolButton>
#include <QPlainTextEdit>
#include <QCryptographicHash>
#include <QMutex>
#include <QMap>
#include <QThread>
#include <QSlider>
#include <QDebug>
#include <QCursor>
#include <QtAVPlayer/qavplayer.h>
#include <QtAVPlayer/qavvideoframe.h>
#include <QtAVPlayer/qavaudiooutput.h>
#include <libavcodec/avcodec.h>

#define APP_VERSION "1.0.0"
#define APP_NAME    "JustVideo"
#define APP_TARGET  "jvideo"

#define PULL_RATE 700

class Actions;
class VidWidget;

struct shared_t
{
    QString conf;
    QString buffPath;
    QString recPath;
    QString camName;
    QString playPath;
    QString recentsPath;
    QString appDataPath;
    QString appConfPath;
    bool    isJM;
    int     windowW;
    int     windowH;
    int     windowX;
    int     windowY;
    int     plistW;
    int     plistH;
    int     plistX;
    int     plistY;
    int     maxViewsPerPage;
    int     maxRecents;
    int     retCode;
};

QStringList lsFiles(const QString &path, const QStringList &filters);
QStringList lsFiles(const QString &path);
QStringList lsVidFiles(const QString &path);
QStringList lsConfFiles(const QString &path);
QStringList lsDirsInDir(const QString &path);
bool        rdConf(const QString &filePath, shared_t *share);
bool        mkPath(const QString &path);
bool        delFolderContents(const QString &path);
bool        runCmd(const QStringList &args, QWidget *parent);
void        createOrUpdateRecent(shared_t *share);
void        wrConf(const QString &filePath, shared_t *share);
void        rdLine(const QString &param, const QString &line, QString *value);
void        rdLine(const QString &param, const QString &line, int *value);
void        rdLine(const QString &param, const QString &line, bool *value);
void        extCorrection(QString &ext);
void        resetSharedRes(shared_t *share);
void        buildGrid(QGridLayout *mainLayout, int parentWidth, const QList<QWidget*> &widList, int cellWidth);

#endif // COMMON_H
