#ifndef FOLDER_DIALOG_H
#define FOLDER_DIALOG_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"

class FolderDialog : public QDialog
{
    Q_OBJECT

private:

    shared_t  *shared;
    QLineEdit *folder;
    QCheckBox *jmFolder;

    void     rd();
    void     wr();
    void     errMsg(const QString &shortMsg, const QString &longMsg);
    void     setWidIntoLayout(QWidget *widget, QHBoxLayout *lay, int wid);
    QWidget *sideBySide(QWidget *left, QWidget *right, int lWid = 0, int rWid = 0);

private slots:

    void run();
    void browse();
    void autoRun();

public:

    explicit FolderDialog(shared_t *conf, bool preFill, QWidget *parent = nullptr);
};

#endif // FOLDER_DIALOG_H
