#ifndef IMG_LOADER_H
#define IMG_LOADER_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"

#define IMG_FROM_VID "#IMG-FROM-VID"

class ImgLoader : public QObject
{
    Q_OBJECT

private:

    QTimer                *timer;
    QMutex                 mutex;
    QAVPlayer             *player;
    QMap<QString, QLabel*> imgQueue;
    QMap<QString, QLabel*> vidQueue;
    QList<QString>         vidProced;
    QAVVideoFrame          rawFrame;
    bool                   vidRunning;
    bool                   seek;

    void resetPlayer();

private slots:

    void loadNextImg();
    void loadNextImgFromVid();
    void rdVideoFrame(const QAVVideoFrame &frame);
    void playerDone(qint64 pos);

public:

    void addImg(const QString &path, QLabel *label);
    void rmImg(const QString &path);
    void clear();

    explicit ImgLoader(QObject *parent);

signals:

    void loop();
    void nextVid();
};

#endif // IMG_LOADER_H
