#ifndef MAIN_WIDGET_H
#define MAIN_WIDGET_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "vid_widget.h"
#include "vid_grid.h"
#include "actions.h"

class MainGui : public QMainWindow
{
    Q_OBJECT

private:

    void closeEvent(QCloseEvent *event);

public:

    explicit MainGui(QWidget *parent = nullptr);

signals:

    void killSes();
};

class MainWidget : public QStackedWidget
{
    Q_OBJECT

private:

    shared_t *shared;
    QMenuBar *menuBar;
    MainGui  *mainGui;
    Actions  *actions;
    QWidget  *homepage;

    void mwMultiViewBuild(QList<shared_t> confs, int page);
    void mwSingleLiveViewBuild(const QString &path, const QString &camName);
    void mwSingleFootageViewBuild(const QString &path, const QString &camName);
    void playPathBuild();
    void setView(QWidget *widget);
    void addVidWidget(VidWidget *vidWidget);

private slots:

    void open();
    void reset();

public:

    explicit MainWidget(shared_t *share, QMenuBar *mainMenuBar, MainGui *parent, Actions *acts);
};

#endif // MAIN_WIDGET_H
