#ifndef PLAY_CONTROL_H
#define PLAY_CONTROL_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "player.h"
#include "playlist_backend.h"

class PlayControl : public QDialog
{
    Q_OBJECT

private:

    QToolButton  *playBtn;
    QToolButton  *pauseBtn;
    QToolButton  *nextBtn;
    QToolButton  *prevBtn;
    QToolButton  *plsBtn;
    QToolButton  *fsBtn;
    QToolButton  *forwardBtn;
    QToolButton  *backBtn;
    QVideoWidget *parentVidWid;
    QTimer       *hideTimer;
    QLabel       *vidName;
    QLabel       *txtPos;

    void showEvent(QShowEvent *event);
    void leaveEvent(QEvent *event);

private slots:

    void stateChanged(QAVPlayer::State newState);
    void vidSrcChanged(const QString &path);

public:

    explicit PlayControl(PlaylistBE *backend, bool pls, Player *media, QVideoWidget *parent);

public slots:

    void resetHide();

signals:

    void playlist();
};

#endif // PLAY_CONTROL_H
