//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "pref_dialog.h"

PrefDialog::PrefDialog(shared_t *conf, QWidget *parent) : QDialog(parent)
{
    shared = conf;

    auto mainLayout = new QVBoxLayout(this);
    auto formWidget = new QWidget(this);
    auto formLayout = new QFormLayout(formWidget);
    auto btnWidget  = new QWidget(this);
    auto btnLayout  = new QHBoxLayout(btnWidget);
    auto okBtn      = new QPushButton(this);
    auto cancelBtn  = new QPushButton(this);

    maxRecents      = new QSpinBox(this);
    maxViewsPerPage = new QSpinBox(this);

    formLayout->addRow(new QLabel(tr("Max Recents:"),        this), maxRecents);
    formLayout->addRow(new QLabel(tr("Max Views Per Page:"), this), maxViewsPerPage);

    btnLayout->addWidget(okBtn);
    btnLayout->addWidget(cancelBtn);

    mainLayout->addWidget(formWidget, 0, Qt::AlignHCenter);
    mainLayout->addWidget(btnWidget, 0, Qt::AlignHCenter);

    okBtn->setText("Ok");
    cancelBtn->setText("Cancel");

    connect(okBtn,     &QPushButton::clicked, this, &PrefDialog::preAccept);
    connect(cancelBtn, &QPushButton::clicked, this, &PrefDialog::reject);

    rd();
}

void PrefDialog::rd()
{
    maxRecents->setValue(shared->maxRecents);
    maxViewsPerPage->setValue(shared->maxViewsPerPage);
}

void PrefDialog::wr()
{
    shared->maxRecents      = maxRecents->value();
    shared->maxViewsPerPage = maxViewsPerPage->value();

    wrConf(shared->appConfPath, shared);
}

void PrefDialog::preAccept()
{
    wr(); accept();
}

