#ifndef RECENTS_H
#define RECENTS_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "actions.h"

class RecentItem : public QObject
{
    Q_OBJECT

private:

    QString  confPath;
    QAction *itemAction;
    Actions *actions;

    QString genItemName();

private slots:

    void triggered();

public:

    explicit RecentItem(const QString &path, Actions *acts, QObject *parent = nullptr);
};

class RecentsSync : public QObject
{
    Q_OBJECT

private:

    QFileSystemWatcher mon;
    shared_t          *share;
    Actions           *actions;

private slots:

    void scan();

public:

    explicit RecentsSync(shared_t *sharedRes, Actions *acts, QObject *parent = nullptr);

signals:

    void sync();
};

#endif // RECENTS_H
