#ifndef VID_GRID_H
#define VID_GRID_H

//    This file is part of JustVideo.

//    JustVideo is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustVideo is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "vid_widget.h"

class VidGrid : public QWidget
{
    Q_OBJECT

private:

    QList<QWidget*> widList;
    QGridLayout    *mainLayout;
    QStackedWidget *mainGui;
    QAction        *menuOption;
    int             widCount;
    int             viewIndex;

    void resizeEvent(QResizeEvent *event);

private slots:

    void viewSelected();
    void closeWid();
    void widCountMinusOne();
    void viewChanged(int index);

public:

    explicit VidGrid(shared_t *share, QList<shared_t> confs, const QString &mntLoc, int pageNum, QMenu *camSelect, QAction *closeAction, QStackedWidget *parent);

signals:

    void stop();
    void front();
};

#endif // VID_GRID_H
